Attribute VB_Name = "Module1"
Option Explicit   ' forces all variables used to be declared before use
Const UDEBUG = 1  ' 0 = no debug stops | 1 = stop ad harcoded debug breaks

Private Sub Main()
    On Error GoTo catch
try:
    ' gpep generic event
    If (UDEBUG) Then
        Stop
    End If
    Dim vHostname As Variant, vCreationDate As Variant, vTerminationDate As Variant
    ' Dim oGpep As GnlPpsEvntPvdr.Gpep  ' variant method parameters passed as VT_BSTR
    Dim oGpep As Object  ' variant method parameters passed as VT_VARIANT | VT_BYREF
    Set oGpep = CreateObject("GnlPpsEvntPvdr.Gpep")
    Call oGpep.Fire("myApp.vbp", "johndoe@mydomain.com", 1694, "c:\path\myApp.vbp")
    'Set oGpep = Nothing
    
    ' gpep create event
    If (UDEBUG) Then
        Stop
    End If
    'Dim oMsi As Object
    'Set oMsi = CreateObject("WindowsInstaller.Installer")
    'vHostname = Environ("computer")
    'vHostname = oMsi.Environment("computername")
    vHostname = oGpep.LocalHostname()
    'vCreationDate = CStr(Date) & " " & CStr(Time)
    'vCreationDate = CStr(Now())
    vCreationDate = oGpep.CurrentWmiDateTime()
    Call oGpep.Fire("myVbApp.vbp", "joeBob@hosterxyz.com", 1666, "c:\path\myVbApp.vbp", vHostname, _
                    vCreationDate)
                    
    ' now wait for a few seconds to simulate application usage duration
    If (UDEBUG) Then
        Stop
    End If
    Dim dtStart As Date, dtCurrent As Date, iTimeSpan As Integer, iWaitInSeconds As Integer
    dtStart = Now
    dtCurrent = Now
    iTimeSpan = Abs(Second(dtCurrent) - Second(dtStart))
    iWaitInSeconds = 10
    While (iTimeSpan < iWaitInSeconds)
        dtCurrent = Now
        iTimeSpan = Abs(Second(dtCurrent) - Second(dtStart))
    Wend
    
    ' gpep terminate event
    If (UDEBUG) Then
        Stop
    End If
    vTerminationDate = oGpep.CurrentWmiDateTime()
    Call oGpep.Fire("myVbApp.vbp", "joeBob@hosterxyz.com", 1666, "c:\path\myVbApp.vbp", vHostname, _
                    vCreationDate, vTerminationDate)
                    
    GoTo finally
catch:
    Dim lTemp As Long, sTemp As String
    lTemp = Err.Number
    sTemp = Err.Source
    sTemp = sTemp & " " & Err.Description
    If (UDEBUG) Then
        Stop
    End If
finally:
    Set oGpep = Nothing
End Sub


