// Gpep.h : Declaration of the CGpep

#ifndef __GPEP_H_
#define __GPEP_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CGpep
class ATL_NO_VTABLE CGpep : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CGpep, &CLSID_Gpep>,
	// public IDispatchImpl<IGpep, &IID_IGpep, &LIBID_GNLPPSEVNTPVDRLib>
	public IDispatchImpl<IGpep, &IID_IGpep, &LIBID_GnlPpsEvntPvdr>
{
public:
	CGpep() {
		// initialize instance member variables
	}

	~CGpep() {
		// uninitialize instance member variables
	}

DECLARE_REGISTRY_RESOURCEID(IDR_GPEP)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CGpep)
	COM_INTERFACE_ENTRY(IGpep)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IGpep
public:
	STDMETHOD(LocalHostname)(/*[out, retval]*/ BSTR *pbsHostname);
	STDMETHOD(CurrentWmiDateTime)(/*[out, retval]*/ BSTR *pbsWmiDateTime);
	// automation interface method used by clients to fire event
	STDMETHOD(Fire)(/*[in]*/ BSTR bsApplication, /*[in]*/ BSTR bsUser, /*[in]*/ INT iNumberValue, /*[in]*/ BSTR bsStringValue, /*[in, optional]*/ VARIANT vHost, /*[in, optional]*/ VARIANT vCreationDate, /*[in, optional]*/ VARIANT vTerminationDate);
};

#endif //__GPEP_H_
